/* YOODA : Yet another Object Oriented Database
   Copyright (C) 1994  Eric Abecassis

This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Library General Public
License as published by the Free Software Foundation; either
version 2 of the License, or (at your option) any later version.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
Library General Public License for more details.

You should have received a copy of the GNU Library General Public
License along with this library; if not, write to the Free
Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA. */


#include <iostream.h>
#include <signal.h>

#include "sockrpc.hxx"
#include "pollset.hxx"
#include "struct_test.hxx"


#include "class_svc.hxx"

int MonObjServ::publish(char*& serv,char*& filter,int& port,int& nbinst)
{
  cout << "--> publish" << endl ;
  cout << serv << endl << filter << endl << port << endl << nbinst << endl;
  cout << "<-- publish" << endl ;
  return nbinst ;
}


char* MonObjServ::subscript(char*& serv, char*& filter, int& port) 
{
  cout << "--> subscript" << endl ;
  cout << serv << endl << filter << endl << endl ;
  port = 4321 ;
  cout << "<-- subscript" << endl ;
  return "spocky" ;
}


void MonObjServ::bench(OID& oid, Page& p) 
{
  p.tab[0] = 10 ;
  p.tab[1] = 20 ;
  p.tab[2] = 30 ;
  p.tab[4093] = 40 ;
  p.tab[4094] = 50 ;
  p.tab[4095] = 60 ;
}


void lineBroken(SvcSocket* s) {
  char name[256] ;
  cout << "Le client sur " << s->tohost(name) << " est tombe " << endl ;
}

MonObjServ svc ;

void Terminate(int) {
  svc.close() ;
  exit(1) ;
}


int main(int argc, char * argv[])
{
  if( argc < 2) {
    cerr << "error: usage : " << argv[0] << " <filter> \n";
    exit(4);
  }

  signal(SIGKILL, ((void (*) (int))Terminate) );
  signal(SIGINT,  ((void (*) (int))Terminate) );
  signal(SIGQUIT, ((void (*) (int))Terminate) );
  signal(SIGTERM, ((void (*) (int))Terminate) );
  signal(SIGSEGV, ((void (*) (int))Terminate) );
  SvcInit() ;

  PollSet    ss;

  char host[256] ;

//  svc.linkBreak(lineBroken) ;

  svc.export(argv[1]) ;
  cerr << "server bound to " << svc.host(host) << " "
       << svc.myport() << "\n";

  ss += &svc ;
  ss.execLoop() ;
}

